(: 
copy: 
	This query just overwrites the input file with itself.
	It's useful as a guideline for other queries, which
	can simply modify the process-element function accordingly
	to the goal they must achieve. 
:)

(: The document to process, from Java :)
declare variable $instance as xs:string external;

(: Process a single element, with an in-depth recursive search :)   
declare function local:process-element ($element) {	
	if ( local:has-children($element) )
		then 		
			element { name($element) } {			
			
				for $attribute in $element/@* 
				return $attribute, 	
				
				for $child in $element/*		
				return local:process-element($child)
				
			}		
		else		
			element { name($element) } {
				for $attribute in $element/@* return $attribute,data($element)
			}
};

(: Test if an element has children :)
declare function local:has-children ($element) {
	if ( count($element/*) = 0 )
		then false()
		else true()
};

(: Starts the processing :)
document {
	local:process-element(doc($instance)/*)
}