(: 
key-generator: 
	This query adds a key to any element which has only children without children.
	
	Author : Marco Quartullo
	Email : marco.quartullo@fastwebnet.it
	Version : 0.2
	
:)


(: Tests if a node has children :)
declare function local:has-children ($element) {

	if ( count($element/*) = 0 )
		then false()
		else true()
};


(: Tests if a node has children with children :)
declare function local:has-children-with-children ($element) {

	if ( count($element/*/*) = 0 )
		then false()
		else true()
};


(: Process an element, with an in-depth recursive traversal :)   
declare function local:process-element ($element) {
	
	if ( not (local:has-children($element)) )
		then 
			element {name($element)} {for $attribute in $element/@* return $attribute,data($element)}
		else
			element {name($element)} {				
				
				for $attribute in $element/@* 
				return $attribute, 	

				if ( not (local:has-children-with-children($element)) )
				then $element/element id {string-join(data($element/*),",")}
				else "",

				for $child in $element/*				
				return local:process-element($child)
			}			
};


(: Process the root children :)
declare function local:key-generator ($root) {
	
	document {
		
		element {name($root)} {						
			
			for $attribute in $root/@* 
			return $attribute, 
			
			for $child in $root/*			
			return local:process-element ($child)
		}					
	}
};


(: The instance to process, passed by Java :)
declare variable $instance as xs:string external;


(: Invoke the query :)
local:key-generator(doc($instance)/*) 