(: Funzione che prende relazioni n_arie e le trasforma in relazioni binarie 

Author : Leonardo Puleggi  
Email : leonardo.puleggi@fastwebnet.it
Version : 0.1

:)

(: The document to process, from Java :)
declare variable $instance as xs:string external;

(: The parameters needed by the query :)
declare variable $name as xs:string external;

(: Process a single element, with an in-depth recursive search
   If an element is a relation, treats it consequently :)   
declare function local:process-element ($element) {	
	if ( (local:has-children($element)) and (name($element) eq $name) )
		then
			local:process-relation($element)
		else if ( local:has-children($element) )
		then 		
			element { name($element) } {									
				for $attribute in $element/@* 
				return $attribute, 	

				for $child in $element/*
				return local:process-element($child)
			}		
		else		
			element { name($element) } {
				for $attribute in $element/@* return $attribute,data($element)
			}
};

(: Process a relation. :)
declare function local:process-relation ($element) {
		let $j := count($element/*)
		let $l := $element/*
		return 
			for $k in 1 to $j,$m in $k+1 to $j
			return 
			element { $name } {
					$l[$k],
					$l[$m]
			}
};

(: Test if an element has children :)
declare function local:has-children ($element) {
	if ( count($element/*) = 0 )
		then false()
		else true()
};

(: Starts the processing :)
document {
	local:process-element(doc($instance)/*)
}