(: Funzione che realizza l'unnesting degli elementi

Author : Leonardo Puleggi  
Email : leonardo.puleggi@fastwebnet.it
Version : 0.1 
:)
declare varialbe $instance as xs:string external;

declare variable $input:=doc($instance);

(: Questa sar la query da richiamare passandogli il nome del file da vedere(eventualmente potrebbe trattarsi di
un elemento nidificato in qualunque modo):)

declare function local:faiUnnesting($risultato){
	let $partenza := $input
 	return element {$risultato} { local:unnesting($partenza[node()]) }
};

(:Funzione ricorsiva che cerca elementi comlessi e fa unnest:)

declare function local:unnesting($padre) {
	let $figli := $padre/child::node() 
	return
		if (count($figli/*)!=0) 
		then
	     ( local:complessi($figli[node()]), local:unnesting($figli[node()]) ) 
	  else() 
};


(: cerco i figli che siano complessi e li applico a creaComplesso:)

declare function local:complessi($figli) {
  let $complessi:= $figli[element()]
  for $k in $complessi 
  where exists($k/*) 
  return local:creaComplesso($k)
};


(:Funzione che crea l'elemento complesso copia i figli e crea il riferimento :)

declare function local:creaComplesso($complesso) { 
	element {name($complesso)} 
	{for $figli in $complesso/* where empty($figli/*) 
	return $figli,local:chiave($complesso),local:riferimentoChiave($complesso)}

};

(:funzione che crea il riferimento:)

declare function local:riferimentoChiave($complesso) {
	for $padre in $complesso/parent::node() 
	(:questo padre ha figli complessi e non  la radice:)
	where ( (some $figlio in $padre/* satisfies $figlio is $complesso) and (name($padre)!="")  ) 
  return 
  (: creo l'elemento in riferimento al padre:)
  element {concat('rif-id-',name($padre))} 
	{if (some $figlio in $padre/* satisfies empty($figlio/*)) 
	then  
		( if (some $figlio in $padre/* satisfies contains(lower-case(name($figlio)),"id")) 
	    then for $key in $padre/* 
	    	where contains(lower-case(name($key)),"id") 
	      return data($key) 
	    else ()) 
	    else (for $each at $nid in $input//* where ($each is $padre) return $nid)}

};

(: la chiave dovrebbe essere gi stata definita ma il problema e' che devo creare la chiave 
per i nuovi elementi come persone nell'esempio:)

declare function local:chiave($complesso) {
	(: caso normale in cui chiave sia gi definita:)
	if (some $figlio in $complesso/* satisfies  contains(lower-case(name($figlio)), "id")) 
	then () 
	(:altrimenti creo elemento chiave:)
	else (element {concat("id-",name($complesso))} 
  {for $i at $k in $input//* where ($i is $complesso) return $k})

};

(: Query di prova:)
local:faiUnnesting("risultato")